// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "display/mesh/Mesh.hpp"
#include "util/mathutils.hpp"

namespace Dawn {
  class CapsuleMesh {
    protected:
      static void calculateRing(
        const int32_t segments,
        const float_t height,
        const float_t radius,
        const float_t dr,
        const float_t y,
        const float_t dy,
        std::vector<glm::vec3> &positions
      );

    public:
      static void create(
        Mesh &mesh,
        const float_t radius,
        const float_t height
      );
  };
}